---
- name: Create controller instance
  gather_facts: false
  hosts: localhost

  tasks:
    - name: Deploy Red Hat Ansible Automation Platform automation controller without private automation hub
      ansible.builtin.include_role:
        name: ansible_ssa.general.instance
      vars:
        instance_name: "{{ controller_instance_name }}"
        instance_group: "controller_group"
        instance_parameters: "{{ controller_instance_parameters | default({}) }}"
        instance_wait_for_connection: true
      when: not controller_ah_enable | default('false') | bool

    - name: Deploy Red Hat Ansible Automation Platform automation controller with private automation hub or RDA
      ansible.builtin.include_role:
        name: ansible_ssa.general.instance
      vars:
        instance_name: "{{ controller_instance_name }}"
        instance_group: "controller_group"
        instance_additional_port: 5432
        instance_parameters: "{{ controller_instance_parameters | default({}) }}"
        instance_wait_for_connection: true
      when: controller_ah_enable | default('false') | bool or controller_eda_enable | default('false')

    - name: Deploy private automation hub
      ansible.builtin.include_role:
        name: ansible_ssa.general.instance
      vars:
        instance_name: "{{ controller_ah_instance_name }}"
        instance_group: "automation_hub_group"
        instance_parameters: "{{ controller_ah_instance_parameters | default({}) }}"
        instance_flavor: t3.xlarge
        instance_wait_for_connection: true
      when: controller_ah_enable | default('false') | bool

    - name: Deploy EDA controller
      ansible.builtin.include_role:
        name: ansible_ssa.general.instance
      vars:
        instance_name: "{{ controller_eda_instance_name }}"
        instance_group: "eda_controller_group"
        instance_parameters: "{{ controller_eda_instance_parameters | default({}) }}"
        instance_wait_for_connection: true
      when: controller_eda_enable | default('false') | bool
